#ifndef __SWABBER_H_
#define __SWABBER_H_
#include "packages.h"

#define LINE_LENGTH 1024
#define TAG_LENGTH 1024

struct top_tag_node {
	char tag_name[TAG_LENGTH];
	struct file_record * not_in_distro_base;
	struct tag_file_record * file_base;;
	void * package_record_base;
	void * wandering_problems_base; /* Actual problems */
	void * wandering_base;  /* Scratch space */
	struct top_tag_node * next;
	struct error_node * error_base;
};

struct tag_file_record {
	struct package_file_record * file;
	struct tag_file_record * next;
};

struct tag_record {
	char tag[TAG_LENGTH];
	int checked;
	struct tag_record * next;
};

struct file_record {
	char filename[LINE_LENGTH];
	unsigned int function_number;
	struct tag_record * tag_base;
	struct package_record * package;
	unsigned int count;
	struct file_record * next;
	struct file_record * prev;
};

#define ERROR_NAME_LENGTH 30

struct error_file_node {
	unsigned int count;
	char filename[FILENAME_LENGTH];
	struct error_file_node * next;
};

struct error_node {
	int error_number;
	char error_name[ERROR_NAME_LENGTH];
	struct error_file_node * file_base;
	struct error_node * next;
};

void shrink_path_dirname(char * p);

#endif
